Scope management

This section contains Scope management proto files.

scopes_manager_service.proto

ScopesManager

This service allows managing scopes. Scopes are logical views of the system that partition access to data. Use scopes to control the privacy or security of data in the system. The scope is identified by an ID determined by the scope creator and by a unique ID generated by the system.

gRPC method definitions

gRPC method definitions
Method Name Request Type Response Type Description
CreateScope CreateScope
Request
CreateScope
Response
Creates a new scope in the system.
RenameScope RenameScope
Request
RenameScope
Response
Renames a scope’s ID.
GetGkScopeId GetGkScopeId
Request
GetGkScopeId
Response
Retrieves a scope’s unique ID.
GetScopeDetails GetScopeDetails
Request
GetScopeDetails
Response
Retrieves a scope’s details.
UpdateScopeDetails UpdateScopeDetails
Request
UpdateScopeDetails
Response
Updates a scope’s details.
SetScopeState SetScopeState
Request
SetScopeState
Response
Sets the scope state to either initialized or active. The other states cannot be set by this method. For marking a scope for deletion, use the MarkScopeForDeletion method.
MarkScopeForDeletion MarkScopeForDeletion
Request
MarkScopeForDeletion
Response
Marks the scope for deletion. Unless this mark is cleared, the scope and all the content are permanently deleted after 30 days. To clear the mark, use UnMarkScopeForDeletion.
UnMarkScopeForDeletion UnMarkScopeForDeletion
Request
UnMarkScopeForDeletion
Response
Clears the deletion flag. Removes the request to delete the scope.
ResetScope ResetScope
Request
ResetScope
Response
Deletes the scope’s content. The scope is reset to its initial state post activation.
ListScopes ListScopes
Request
ListScopes
Response
Lists the scopes in the system.
SetScopeResource SetScopeResource
Request
SetScopeResource
Response
Creates scope’s resources.
GetScopeResource GetScopeResource
Request
GetScopeResource
Response
Gets scope’s resources.
UpdateASRaaSCredentials UpdateASRaaSCredentials
Request
UpdateASRaaSCredentials
Response
Updates the ASRaaS resource credentials.

Methods with HTTP bindings

CreateScope

  POST /v1/scopes  

RenameScope

  PATCH /v1/scopes/{gk_scope_id.value}/scope_id  

GetGkScopeId

  GET /v1/scopes/{scope_id}/gkid  

GetScopeDetails

  GET /v1/scopes/{gk_scope_id.value}  

UpdateScopeDetails

  PATCH /v1/scopes/{gk_scope_id.value}  

SetScopeState

  PUT /v1/scopes/{gk_scope_id.value}/state  

MarkScopeForDeletion

  PUT /v1/scopes/{gk_scope_id.value}/attributes/deleted  

UnMarkScopeForDeletion

  DELETE /v1/scopes/{gk_scope_id.value}/attributes/deleted  

ResetScope

  PUT /v1/scopes/{gk_scope_id.value}/reset  

ListScopes

  GET /v1/scopes  

SetScopeResource

  POST /v1/scopes/{gk_scope_id.value}/resources  

GetScopeResource

  GET /v1/scopes/{gk_scope_id.value}/resources/{resource_name}  

UpdateASRaaSCredentials

  POST /v1/scopes/{gk_scope_id.value}/update-asraas-credentials  

scopes_manager_messages.proto

CreateScopeRequest

Input message that defines parameters for CreateScope.

CreateScopeRequest
Field Type Description
scope_id string Mandatory. The scope identifier provided by the scope creator.
details ScopeDetailsForCreate Optional. Additional information about the scope.
field_mask google.protobuf.FieldMask Optional. A field mask used to specify the ScopeDetailsForCreate fields that the method sets.
scope_profile ScopeProfile Mandatory. Scope profile.
expected_persons_number int32 Mandatory. Expected number of persons in the scope.

CreateScopeResponse

Output message that defines parameters returned by CreateScope.

CreateScopeResponse
Field Type Description
status nuance.rpc.Status Mandatory. General operation status.
gk_scope_id nuance.biosec.v1.UniqueId Optional. Unique ID of the newly created scope.

GetGkScopeIdRequest

Input message that defines parameters for GetGkScopeId.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Optional
  • configset_id: Not used
GetGkScopeIdRequest
Field Type Description
context nuance.biosec.v1.Context Optional. General request context.
scope_id string Mandatory. Identifies the scope.

GetGkScopeIdResponse

Output message that defines parameters returned by GetGkScopeId.

GetGkScopeIdResponse
Field Type Description
status nuance.rpc.Status Mandatory. General operation status.
gk_scope_id nuance.biosec.v1.UniqueId Optional. Scopes’s unique ID.

GetScopeDetailsRequest

Input message that defines parameters for GetScopeDetails.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Optional
  • configset_id: Not used
GetScopeDetailsRequest
Field Type Description
context nuance.biosec.v1.Context Optional. General request context.
gk_scope_id nuance.biosec.v1.UniqueId Mandatory. Scope’s unique ID.
field_mask google.protobuf.FieldMask Optional. A field mask used to specify the ScopeDetailsForRead fields that the method reads.

GetScopeDetailsResponse

Output message that defines parameters returned by GetScopeDetails.

GetScopeDetailsResponse
Field Type Description
status nuance.rpc.Status Mandatory. General operation status.
details ScopeDetailsForRead Optional. Scope’s details.

GetScopeResourceRequest

Input message that defines parameters for GetScopeResource.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Optional
  • configset_id: Not used
GetScopeResourceRequest
Field Type Description
context nuance.biosec.v1.Context Optional. General request context.
gk_scope_id nuance.biosec.v1.UniqueId Mandatory. Scopes’s unique ID.
resource_name string Mandatory. Resource’s name. The following resource names are supported:* cassandra * minio * kibana * encryption * signing * media_manager * asraas

GetScopeResourceResponse

Output message that defines parameters returned by SetScopeResource.

GetScopeResourceResponse
Field Type Description
status nuance.rpc.Status Mandatory. General operation status.
resource_parameters repeated GetScopeResourceResponse.ResourceParametersEntry Optional. List of the resource’s parameters.

GetScopeResourceResponse.ResourceParametersEntry

GetScopeResourceResponse.ResourceParametersEntry
Field Type Description
key string  
value string  

ListScopesRequest

Input message that defines parameters for ListScopes.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Not used
  • configset_id: Not used
ListScopesRequest
Field Type Description
context nuance.biosec.v1.Context Optional. General request context.
field_mask google.protobuf.FieldMask Optional. A field mask used to specify the ScopeDetailsForRead that the method reads.

ListScopesResponse

Output message that defines parameters returned by ListScopes.

ListScopesResponse
Field Type Description
status nuance.rpc.Status Mandatory. General operation status.
details repeated ScopeDetailsForRead Optional. List of scopes details.

MarkScopeForDeletionRequest

Input message that defines parameters for MarkScopeForDeletion.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Optional
  • configset_id: Not used
MarkScopeForDeletionRequest
Field Type Description
context nuance.biosec.v1.Context Optional. General request context.
gk_scope_id nuance.biosec.v1.UniqueId Mandatory. Scope’s unique ID.

MarkScopeForDeletionResponse

Output message that defines parameters returned by MarkScopeForDeletion.

MarkScopeForDeletionResponse
Field Type Description
status nuance.rpc.Status Mandatory. General operation status.

RenameScopeRequest

Input message that defines parameters for RenameScope.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Optional
  • configset_id: Not used
RenameScopeRequest
Field Type Description
context nuance.biosec.v1.Context Optional. General request context.
gk_scope_id nuance.biosec.v1.UniqueId Mandatory. Scope’s unique ID.
new_scope_id string Mandatory. Scope’s new ID. It must be unique.

RenameScopeResponse

Output message that defines parameters returned by RenameScope.

RenameScopeResponse
Field Type Description
status nuance.rpc.Status Mandatory. General operation status.

ResetScopeRequest

Input message that defines parameters for ResetScope.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Optional
  • configset_id: Not used
ResetScopeRequest
Field Type Description
context nuance.biosec.v1.Context Optional. General request context.
gk_scope_id nuance.biosec.v1.UniqueId Mandatory. Scope’s unique ID.

ResetScopeResponse

Output message that defines parameters returned by ResetScope.

ResetScopeResponse
Field Type Description
status nuance.rpc.Status Mandatory. General operation status.

ScopeDetailsForCreate

Contains fields that the system uses to create a scope. Included in CreateScopeRequest.

ScopeDetailsForCreate
Field Type Description
customer_name string Optional. Name of the customer owning the scope.
description string Optional. Description of the purpose of the scope.
is_billable bool Optional. Determines if the activity on this scope is billable.
go_live_timestamp google.protobuf.Timestamp Optional. The scope’s go-live time. This information is used for billing.
scope_type ScopeType Optional. The scope’s type.

ScopeDetailsForRead

Contains the readable fields of the Scope. Included in ListScopesResponse and GetScopeDetailsResponse.

ScopeDetailsForRead
Field Type Description
gk_scope_id nuance.biosec.v1.UniqueId Optional. Scope’s unique ID.
scope_id string Optional. Scope’s identifier. Must be unique at least at the scope level.
customer_name string Optional. Name of the customer owning the scope.
description string Optional. Description of the purpose of the scope.
is_billable bool Optional. Determines if the activity on this scope is billable.
scope_state ScopeState Optional. The scope’s state.
go_live_timestamp google.protobuf.Timestamp Optional. The scope’s go-live time. This information is used for billing.
scope_profile ScopeProfile Optional. The scope profile.
scope_type ScopeType Optional. The scope’s type.
expected_persons_number google.protobuf.Int32Value Optional. Expected number of persons in the scope.
creation_timestamp google.protobuf.Timestamp Optional. Date and time of the scope creation.
modification_timestamp google.protobuf.Timestamp Optional. Date and time of the scope last update.

ScopeDetailsForUpdate

Contains the writable fields of the Processed Audio Segment. Included in UpdateScopeDetailsRequest.

ScopeDetailsForUpdate
Field Type Description
customer_name string Optional. Name of the customer owning the scope.
description string Optional. Description of the purpose of the scope.
is_billable bool Optional. Determines if the activity on this scope is billable.
go_live_timestamp google.protobuf.Timestamp Optional. The scope’s go-live time. This information is used for billing.
scope_type ScopeType Optional. The scope’s type.
expected_persons_number google.protobuf.Int32Value Optional. Expected number of persons in the scope. NOTE: The updated number will affect only future usages.

SetScopeResourceRequest

Input message that defines parameters for SetScopeResource.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Optional
  • configset_id: Not used
SetScopeResourceRequest
Field Type Description
context nuance.biosec.v1.Context Optional. General request context.
gk_scope_id nuance.biosec.v1.UniqueId Mandatory. Scopes’s unique ID.
resource_name string Mandatory. Resource’s name.
resource_parameters repeated SetScopeResourceRequest.ResourceParametersEntry Mandatory. Resource’s parameters.
secured_resource_parameters repeated SetScopeResourceRequest.SecuredResourceParametersEntry Mandatory. Secured resource parameters. GetScopeResource does not return these parameters.

SetScopeResourceRequest.ResourceParametersEntry

SetScopeResourceRequest.ResourceParametersEntry
Field Type Description
key string  
value string  

SetScopeResourceRequest.SecuredResourceParametersEntry

SetScopeResourceRequest.SecuredResourceParametersEntry
Field Type Description
key string  
value string  

SetScopeResourceResponse

Output message that defines parameters returned by SetScopeResource.

SetScopeResourceResponse
Field Type Description
status nuance.rpc.Status Mandatory. General operation status.

SetScopeStateRequest

Input message that defines parameters for SetScopeState.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Optional
  • configset_id: Not used
SetScopeStateRequest
Field Type Description
context nuance.biosec.v1.Context Optional. General request context.
gk_scope_id nuance.biosec.v1.UniqueId Mandatory. Scope’s unique ID.
scope_state ScopeState Mandatory. The scope’s state.

SetScopeStateResponse

Output message that defines parameters returned by SetScopeState.

SetScopeStateResponse
Field Type Description
status nuance.rpc.Status Mandatory. General operation status.

UnMarkScopeForDeletionRequest

Input message that defines parameters for UnMarkScopeForDeletion.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Optional
  • configset_id: Not used
UnMarkScopeForDeletionRequest
Field Type Description
context nuance.biosec.v1.Context Optional. General request context.
gk_scope_id nuance.biosec.v1.UniqueId Mandatory. Scope’s unique ID.

UnMarkScopeForDeletionResponse

Output message that defines parameters returned by MarkScopeForDeletion.

UnMarkScopeForDeletionResponse
Field Type Description
status nuance.rpc.Status Mandatory. General operation status.

UpdateASRaaSCredentialsRequest

Input message that defines parameters for UpdateASRaaSCredentials.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Optional
  • configset_id: Not used
UpdateASRaaSCredentialsRequest
Field Type Description
context nuance.biosec.v1.Context Optional. General request context.
gk_scope_id nuance.biosec.v1.UniqueId Mandatory. Scopes’s unique ID.
client_id string Mandatory. ASRaaS client Id.
client_secret string Mandatory. ASRaaS client secret.

UpdateASRaaSCredentialsResponse

Output message that defines parameters returned by UpdateASRaaSCredentials.

UpdateASRaaSCredentialsResponse
Field Type Description
status nuance.rpc.Status Mandatory. General operation status.

UpdateScopeDetailsRequest

Input message that defines parameters for UpdateScopeDetails.

Uses the context field as follows:

  • gk_engagement_id: Not used
  • gk_session_id: Not used
  • gk_scope_id: Optional
  • configset_id: Not used
UpdateScopeDetailsRequest
Field Type Description
context nuance.biosec.v1.Context Optional. General request context.
gk_scope_id nuance.biosec.v1.UniqueId Mandatory. Scope’s unique ID.
details ScopeDetailsForUpdate Mandatory. Details that the method updates.
field_mask google.protobuf.FieldMask Mandatory. A field mask used to specify the ScopeDetailsForUpdate fields that the method sets.

UpdateScopeDetailsResponse

Output message that defines parameters returned by UpdateScopeDetails.

UpdateScopeDetailsResponse
Field Type Description
status nuance.rpc.Status Mandatory. General operation status.

scopes_manager_enums.proto

ScopeProfile

The scope profile. Serves as an indication of the scope size. Contact your system administrator for more information about profile options.

Name Number Description
SCOPE_PROFILE_UNSPECIFIED 0 Scope profile is not set.
SCOPE_PROFILE_SMALL 1 Scope profile is set to small.
SCOPE_PROFILE_MEDIUM 2 Scope profile is set to medium.
SCOPE_PROFILE_LARGE 3 Scope profile is set to large.
SCOPE_PROFILE_DEFAULT 4 Scope profile is set to a predefined default value.
SCOPE_PROFILE_0 10 Scope profile is set to a minimum of 0k annual transactions.
SCOPE_PROFILE_100K 20 Scope profile is set to a minimum of 100k annual transactions.
SCOPE_PROFILE_5M 30 Scope profile is set to a minimum of 5M annual transactions.
SCOPE_PROFILE_10M 40 Scope profile is set to a minimum of 10M annual transactions.
SCOPE_PROFILE_50M 50 Scope profile is set to a minimum of 50M annual transactions.
SCOPE_PROFILE_100M 60 Scope profile is set to a minimum of 100M annual transactions.
SCOPE_PROFILE_200M 70 Scope profile is set to a minimum of 200M annual transactions.

ScopeState

In case the scope is deleted before it is set to active, the system deletes the scope immediately. In case the scope is deleted after it is set to active, it is pending for deletion (but still operational) for 30 days. If the pending for deletion is revoked, the scope is set back to the ready state.

Name Number Description
SCOPE_STATE_UNSPECIFIED 0 Scope state is not set.
SCOPE_STATE_CREATED 1 Scope entity is created but not ready for use.
SCOPE_STATE_INITIALIZED 2 Scope settings are done, waiting for microservices to complete their initialization.
SCOPE_STATE_INITIALIZATION_FAILURE 3 Failure during initialization.
SCOPE_STATE_READY 4 All microservices reported ready.
SCOPE_STATE_ACTIVE 5 Scope is activated.
SCOPE_STATE_PENDING_DELETION 6 Scope is marked for deletion.
SCOPE_STATE_DELETED 7 Scope-related data is deleted, and scope is marked as deleted.

ScopeType

The scope type.

Name Number Description
SCOPE_TYPE_UNSPECIFIED 0 Scope type is not set.
SCOPE_TYPE_PRODUCTION 1 Scope type is set to production.
SCOPE_TYPE_INTERNAL 2 Scope type is set to internal.
SCOPE_TYPE_DEMO 3 Scope type is set to demo.
SCOPE_TYPE_SMDC 4 Scope type is set to silent mode data collection.